<?php

namespace domain\PointSale\SharedPointSale;

use domain\_\AbstractRepository;
use domain\PointSale\PointSale\PointSale;

class SharedPointSaleRepository extends AbstractRepository
{
    protected SharedPointSaleRepositoryQuery $sharedPointSaleRepositoryQuery;

    public function loadDependencies(): void
    {
        $this->loadQuery(SharedPointSaleRepositoryQuery::class);
    }

    public function getDefaultOptionsSearch(): array
    {
        return [
            self::WITH => [],
            self::JOIN_WITH => ['pointSaleRelation'],
            self::ORDER_BY => '',
            self::ATTRIBUTE_ID_PRODUCER => ''
        ];
    }

    public function findOneSharedPointSaleById(int $id)
    {
        return $this->createQuery()
            ->filterById($id)
            ->findOne();
    }

    public function findSharedPointsSaleRequestsOfMe()
    {
        return $this->createQuery()
            ->filterByProducerOfPointSale($this->getProducerContext())
            ->filterIsRequest()
            ->find();
    }

    public function findSharedPointsSaleRequestsOthers()
    {
        return $this->createQuery()
            ->filterByProducerWithSharing($this->getProducerContext())
            ->filterIsRequest()
            ->find();
    }

    public function findSharedPointsSaleConfirmedByPointSale(PointSale $pointSale)
    {
        return $this->createQuery()
            ->filterByPointSale($pointSale)
            ->filterIsConfirmed()
            ->find();
    }
}